// Profiler.cpp: implementation of the CProfiler class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Profiler.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



template<> bool CSingleton< CProfiler >::Create()
{
	DAEDALUS_ASSERT_Q(mpInstance == NULL);
	
	mpInstance = new CProfiler();

	return true;
};

const CProfiler::ProfileInfo CProfiler::s_ItemInfo[ NUM_PROFILE_ITEMS ] =
{
	{ PROFILE_FRAME,		PROFILE_FRAME,		"Frame" },
	{ PROFILE_GFX,			PROFILE_FRAME,		"Graphics" },
	{ PROFILE_AUD,			PROFILE_FRAME,		"Audio" },
	{ PROFILE_DYNAREC,		PROFILE_FRAME,		"Dynarec" },
	{ PROFILE_GFX_TCACHE,	PROFILE_GFX,		"Gfx: TCache" },
	{ PROFILE_GFX_CONVERT,	PROFILE_GFX,		"Gfx: Convert" },
	{ PROFILE_GFX_COMBINER, PROFILE_GFX,		"Gfx: Combine" }

};
